import sys, os

def subprocess_result(library, behavior, kind):
    input = os.popen("python f2py_tests.py %s %s %s" %
                     (library,behavior,kind), "r", 32768)
    return input.read()
    
def main():
    library = "Numeric"
    behavior = "standard"
    expected = {}
    for kind in kinds:
        print "Numeric", "standard", kind
        expected[kind] = subprocess_result(library, behavior, kind)
        # print expected[kind]

    library = "numarray"
    for behavior in ["standard","byteswapped","misaligned","strided"]:
        for kind in kinds:
            got = subprocess_result(library, behavior, kind)
            if got != expected[kind]:
                print "Unexpected result for", repr(behavior), "in test", repr(kind)
                print "Expected:"
                print expected[kind]
                print "Got:"
                print got
                print "*"*65
            else:
                print "numarray", behavior, kind, "ok"


if __name__ == "__main__":
    if len(sys.argv) < 2:
        kinds = ["in_f","in_c","in_comma_out_f","in_comma_out_c",
                 "inout_f","inout_c"]  # ,"out_f","out_c"]
    else:
        kinds = sys.argv[1:]
        
    main()
